package info.bukova.isspst.data;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import org.hibernate.annotations.LazyCollection;
import org.hibernate.annotations.LazyCollectionOption;

@Entity
@Table(name = "TRIP_BILL")
public class TripBill extends BaseData {

	@OneToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "REQUIREMENT_ID")
	private TripRequirement requirement;
	@Column(name = "RESULT_MESSAGE_DATE")
	private Date resultMessageDate;
	@Column(name = "SIGN_DATE")
	private Date signDate;
	@Column(name = "FREE_MEALS")
	private boolean freeMeals;
	@Column(name = "FREE_HOUSING")
	private boolean freeHousing;
	@Column(name = "FREE_CAREFARE")
	private boolean freeCarfare;
	@OneToMany(cascade = CascadeType.ALL, orphanRemoval = true)
	@LazyCollection(LazyCollectionOption.TRUE)
	@JoinColumn(name = "TRIP_BILL_ID")
	private List<TripBillItem> billItems;
	@Column(name = "ATTACHEMENTS_COUNT")
	private int attachementsCount;
	@Column(name = "DOWN_PAYMENT", precision = 15, scale = 4)
	private BigDecimal downPayment;
	@Column(name = "TOTAL", precision = 15, scale = 4)
	private BigDecimal total;
	
	public TripBill() {
		billItems = new ArrayList<TripBillItem>();
	}

	public TripRequirement getRequirement() {
		return requirement;
	}

	public void setRequirement(TripRequirement requirement) {
		this.requirement = requirement;
	}

	public Date getResultMessageDate() {
		return resultMessageDate;
	}

	public void setResultMessageDate(Date resultMessageDate) {
		this.resultMessageDate = resultMessageDate;
	}

	public Date getSignDate() {
		return signDate;
	}

	public void setSignDate(Date signDate) {
		this.signDate = signDate;
	}

	public boolean isFreeMeals() {
		return freeMeals;
	}

	public void setFreeMeals(boolean freeMeals) {
		this.freeMeals = freeMeals;
	}

	public boolean isFreeHousing() {
		return freeHousing;
	}

	public void setFreeHousing(boolean freeHousing) {
		this.freeHousing = freeHousing;
	}

	public boolean isFreeCarfare() {
		return freeCarfare;
	}

	public void setFreeCarfare(boolean freeCarfare) {
		this.freeCarfare = freeCarfare;
	}

	public List<TripBillItem> getBillItems() {
		return billItems;
	}

	public void setBillItems(List<TripBillItem> billItems) {
		this.billItems = billItems;
	}

	public BigDecimal getDownPayment() {
		return downPayment;
	}

	public void setDownPayment(BigDecimal downPayment) {
		this.downPayment = downPayment;
	}

	public BigDecimal getTotal() {
		return total;
	}

	public void setTotal(BigDecimal total) {
		this.total = total;
	}

}
