package info.bukova.isspst.services.requirement;

import info.bukova.isspst.Constants;
import info.bukova.isspst.data.Requirement;
import info.bukova.isspst.data.RequirementState;
import info.bukova.isspst.data.User;
import info.bukova.isspst.data.Workflow;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;

public class RequirementServiceImpl extends
		RequirementBaseServiceImpl<Requirement> implements RequirementService,
		RequirementBaseService<Requirement> {

	@Autowired
	private RequirementTypeService reqTypeService;

	@Override
	protected Requirement createEntity() {
		Requirement entity = new Requirement();

		entity.setReqDate(new Date());
		entity.setType(reqTypeService.getTypeById(Constants.REQTYPE_ORDER));
		entity.setState(RequirementState.NEW);

		return entity;
	}

	@Override
	protected boolean autoApprove(Requirement entity) {
		List<User> approvers = this.getNextApprover(entity);
		Workflow nextWf = this.getNextWorkflow(entity);
		
		if (approvers == null || approvers.isEmpty() || nextWf == null || nextWf.getLimit() == null) {
			return false;
		}
		
		if (entity.getSumTotal().compareTo(nextWf.getLimit()) == -1) {
			approve(entity, approvers.get(0));
			return true;
		}
		
		return false;
	}

}
